//	UniversalSymbols.h
//
//  Determines the system, and loads the appropriate header file.  This is a good
//  candidate for precompiling if your platform supports it.

#ifndef 	UT_UNIVSYM
#define		UT_UNIVSYM

#if (macintosh) // "macintosh" is the CodeWarrior symbol defined when compiling to Mac.
	#define TARGET_API_MAC_CARBON 1
	#define UT_TARGET_WIN32 			0
	#define UT_TARGET_MACOS				1
	#define	UT_NATIVE_ENDIAN_MOTOROLA	1
	#define UT_NATIVE_ENDIAN_INTEL		0
	#include "UniversalSymbolsMac.h"
	
#elif defined(__INTEL__) // "__INTEL__" defined by CodeWarrior on Windows only. 
	#define UT_TARGET_WIN32 			1
	#define UT_TARGET_MACOS				0
	#define	UT_NATIVE_ENDIAN_MOTOROLA	0
	#define UT_NATIVE_ENDIAN_INTEL		1
	#include "UniversalSymbolsWin.h"
	
#else
	#error No Platform Defined
#endif


#include "PortErrors.h"

#endif // Defined UT_UNIVSYM
