#if (UT_TARGET_MACOS)

// Define a bunch of abstract types and variables into their mac equivalents.
// This makes portable code easier.

#include <QuickDraw.h>
#include <QDOffscreen.h>
#include <MacWindows.h>
#include <Icons.h>
#include <Menus.h>
#include <Controls.h>

//#include <Carbon.h>

namespace PortableViews {
// Universal Types File
//typedef short 				bool;

typedef unsigned char 		uByte;
typedef signed char			sByte;

typedef unsigned char		uInt8;
typedef signed char			sInt8;
typedef signed char			int8;

typedef unsigned short		uInt16;
typedef short				sInt16;
typedef short				int16;

typedef unsigned long		uInt32;
typedef long				sInt32;
typedef long				int32;

typedef unsigned long long	uInt64;
typedef long long			sInt64;
typedef long long			int64;

typedef	double				loFloat;
typedef long double			hiFloat;

typedef	void*				universalPtr;

typedef PicHandle			platformMetaFile;

typedef	GWorldPtr			platformOffscreen;

typedef	GWorldPtr			platformBitmap;

struct	platformMaskableBitmap {
	platformBitmap bitmap;
	platformBitmap mask;
};

struct	platformPoint {
	int16	x;
	int16	y;
	};
	
struct	platformLongPoint {
	int32	x;
	int32	y;
	};

// A rectangle, and a whole slew of accessor functions for it.
typedef Rect		platformRect;
inline void SetRectLeft(platformRect* theRect, int16 val) { theRect->left = val; }
inline void SetRectRight(platformRect* theRect, int16 val) { theRect->right = val; }
inline void SetRectTop(platformRect* theRect, int16 val) { theRect->top = val; }
inline void SetRectBottom(platformRect* theRect, int16 val) { theRect->bottom = val; }
inline void SetRectTLBR(platformRect* theRect, sInt16 t, sInt16 l, sInt16 b, sInt16 r)
			{ theRect->top = t; theRect->bottom = b; theRect->left = l; theRect->right = r; }
inline void SetRectLTRB(platformRect* theRect,  int16 l, int16 t, int16 r, int16 b)
			{ theRect->top = t; theRect->bottom = b; theRect->left = l; theRect->right = r; }

inline int16 GetRectLeft(platformRect* theRect) { return theRect->left; }
inline int16 GetRectRight(platformRect* theRect) { return theRect->right; }
inline int16 GetRectTop(platformRect* theRect) { return theRect->top; }
inline int16 GetRectBottom(platformRect* theRect) { return theRect->bottom; }
	
// A color spec, and a whole slew of accessor functions for it, too
typedef	RGBColor	platformRGBColor;
inline void	SetColorRed(platformRGBColor* color, uInt8 val) { color->red = 
			static_cast<unsigned short>(((static_cast<unsigned short>(val))<<8)+val); }	
inline void	SetColorGreen(platformRGBColor* color, uInt8 val) { color->green = 
			static_cast<unsigned short>(((static_cast<unsigned short>(val))<<8)+val); }	
inline void	SetColorBlue(platformRGBColor* color, uInt8 val) { color->blue = 
			static_cast<unsigned short>(((static_cast<unsigned short>(val))<<8)+val); }	
inline void	SetColorRGB(platformRGBColor* color, uInt8 r, uInt8 g, uInt8 b) 
	{ 	
	color->red = static_cast<unsigned short>(((static_cast<unsigned short>(r))<<8)+r); 
	color->green = static_cast<unsigned short>(((static_cast<unsigned short>(g))<<8)+g); 
	color->blue = static_cast<unsigned short>(((static_cast<unsigned short>(b))<<8)+b); 
	}	


typedef WindowRef	platformWindow;
typedef void* platformWindowProc; // No such thing
	
struct	platformDC {
	bool		isWindow;
	CGrafPtr	theGrafPtr;
	GWorldPtr	theGWorld;
	GDHandle	theGDevice;
	WindowPtr	theWindow;
	};

struct	platformTextSpecs {
	FMFontFamily	theFontFamily;
	unsigned char	theName[256];
	FMFontStyle		theStyle;
	short			theSize;
	};

typedef FontInfo platformFontMetrics;

inline double 	GetMetricAscent(const platformFontMetrics& fm)
	{
	return fm.ascent;
	}
	
inline double	GetMetricDescent(const platformFontMetrics& fm)
	{
	return fm.descent;
	}

typedef	CIconHandle	platformIcon;

typedef MenuHandle	platformMenu;
typedef Handle		platformMenuBar;

typedef CursHandle	platformCursor;

typedef	ControlHandle	platformControl;

typedef	RgnHandle		platformRgn;
typedef	PolyHandle		platformPoly;

typedef	sInt16			platformOpenFileHandle;

typedef	char*				CStringPtr;
typedef const char * const	constCStringPtr;

typedef unsigned char*		PStringPtr;
typedef const unsigned char* const constPStringPtr;

typedef sInt32 				charLong;
typedef sInt16 				resID;

typedef	unsigned char		PString31[32];
typedef unsigned char		PString255[256];
} // namespace PortableViews

#endif
