//
//	PortWindowAll.cp

// This class is being provided because it implements some of the dialog functionality.
// It's been heavily hacked to elimintate a dependence on the rest of an application
// framework.  Enough remains to use as a rudimentary window class if you like, but this
// is not the focus of the provided code.
//
#include "UniversalSymbols.h"

#include <map>
#include "Window.h"

namespace PortableViews {

std::map<platformWindow, PortWindow*>	PortWindow::sWindowMap;	

//static	
//@method:PortWindow::PlatformWindowToPortWindow
//@arg:win:platformWindow
//@descr
// This static method returns the PortWindow that's associated with the
// platformWindow, or NULL if the platformWindow doesn't point to a
// valid PortWindow.  (The implementation of this routine has changed under 
// PortableViews 1.0, the old way had too many undefined behaviours.  This is a 
// little more expensive, but it works.)
//@endm  
PortWindow*	PortWindow::PlatformWindowToPortWindow(platformWindow win)
	{
	PortWindow* theWin = NULL;
	
	if (sWindowMap.find(win) != sWindowMap.end())
		theWin = sWindowMap[win];
		
	return theWin;
	}

} // namespace PortableViews


