// main.cpp
//
// A sample file to demo this whole system.  We're basically going
// to create and display three different dialogs in sequence.  The
// dialogs are hardcoded here, but in a real implementation they would
// likely have been read in from resources, XML, or some other external
// mechanism.
//

#include "UniversalSymbols.h"
#include "Window.h"
#include "DemoDialogs.h"
#include "BasicWinProc.h"

using namespace PortableViews;

#if (UT_TARGET_MACOS)
int main(void)
	{
	DemoDialogs();
	return 0;
	}
	
#else
HINSTANCE gAppInstance;
HWND	  gAppWindow;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/,
                    PSTR /*szCmdLine*/, int iCmdShow)
	{
	InitCommonControls();
	
	// Note the instance for future (windows only) reference
	gAppInstance = hInstance;
		
	// Register an application window class
	WNDCLASSEX  wndclass;
	wndclass.cbSize        = sizeof (wndclass) ;
	wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
	wndclass.lpfnWndProc   = StandardWndProc ;
	wndclass.cbClsExtra    = 0 ;
	wndclass.cbWndExtra    = 0 ;
	wndclass.hInstance     = gAppInstance ;
	wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
	wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
	wndclass.lpszMenuName  = NULL ;
	wndclass.lpszClassName = "PortViewsWindowBase" ;
	wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION) ;
	ATOM err = RegisterClassEx (&wndclass);
	PortAssert(err);

	gAppWindow = PortWindow::CreatePlatformWindow();
	if (gAppWindow)
		{
		char name[] = "PortViews Demo";
	    SetWindowText(gAppWindow, (const char*)name);
		ShowWindow(gAppWindow, iCmdShow) ;
		UpdateWindow(gAppWindow);
		}
			
		// And get the framework going.
	MSG         msg ;
	bool iQuitting = false;
	while (!iQuitting)
	 	{
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
			if (msg.message == WM_QUIT)
				iQuitting = true;
			TranslateMessage (&msg);
			DispatchMessage (&msg);
			}
		else
			{
			static bool haveDoneThis = false;
			if (!haveDoneThis)
				{
				DemoDialogs();
				haveDoneThis = true;
				}
			}
		}

	return  msg.wParam;
    }
#endif