#pragma warning (disable : 4503 4675)

#include "Variant.h"
#include <string>
#include <cassert>
#include <iostream>

using namespace std;

int main()
{
    try 
    {
        typedef Variant<TYPELIST_3(string, int, double)> DBField;
        
        DBField fld1(string("Hello, world"));
        DBField fld2(25);
        DBField fld3(3.14);
    
        assert(fld2.TypeId() == typeid(int));
    
        string* p = fld1.GetPtr<string>();
        assert(p != 0);
        *p += '!';
        assert(*fld1.GetPtr<std::string>() == "Hello, world!");

        DBField fld5;

        assert(fld5.TypeId() == typeid(string));
        assert(fld5.GetPtr<string>()->empty());

        DBField fld4 = fld1;
        assert(fld4.TypeId() == typeid(string));
        assert(*fld4.GetPtr<std::string>() == "Hello, world!");

        DBField fld(45);
        float f = fld.ConvertTo<float>();
        assert(f == 45);

        fld2.ChangeType<double>();
        assert(*fld2.GetPtr<double>() == 25);

        // The construct below didn't work on any compiler
        //typedef Variant<TYPELIST_3(string, int, float)> AlternateDBField;    
        //AlternateDBField fld6(fld1);
    }
    catch (const std::exception& e)
    {
        cout << "Something weird happened: " << e.what();
    }
    catch (...)
    {
        cout << "Something really weird happened.";
    }
}

